stages:
        - env
        - deploy

prepare env:
        stage: env
        image: rancher/terraform-controller-executor
        script:
                - cd terra/dev
                - export AWS_ACCESS_KEY_ID=$AWS_ACCESS_KEY_ID
                - export AWS_SECRET_ACCESS_KEY=$AWS_SECRET_ACCESS_KEY
                - export AWS_DEFAULT_REGION=us-east-1
                - terraform init
                - terraform apply --auto-approve
                - terraform output PUBLIC-IP >> build.env
        artifacts:
                reports:
                        dotenv: 
                                - /builds/torresch.bianca/webdeploy-gitlab/terra/dev/build.env

deploy website:
        stage: deploy
        image: alpine:latest
        before_script:
                - 'command -v ssh-agent >/dev/null || ( apk add --update openssh )' 
                - eval $(ssh-agent -s)
                - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
                - mkdir -p ~/.ssh
                - chmod 700 ~/.ssh
                - ssh-keyscan $PUBLICIP >> ~/.ssh/known_hosts
                - chmod 644 ~/.ssh/known_hosts
        script:
                - echo "Deploying started..."
                - scp -r ./client ./*.json ./*.js ./scripts/run-app.sh ./scripts/script.service ubuntu@$PUBLICIP:~/node-app/
                - ssh ubuntu@$PUBLICIP "chmod +x ~/node-app/run-app.sh"
                - ssh ubuntu@$PUBLICIP "sudo mv ~/node-app/*.service /lib/systemd/system/"
                - ssh ubuntu@$PUBLICIP "sudo systemctl daemon-reload && sudo systemctl enable script.service && sudo systemctl restart script.service"
                - echo "Finished deploying, check the app in http://$PUBLICIP:3000"
        artifacts:
                paths:
                        - ./client
                        - ./*.json
                        - ./*.js